#include "kiss.h"

size_t kiss_encode_dataframe(uint8_t *output, uint8_t *input, size_t length) {
  if (output) {
    uint8_t *output_start = output, byte;
    *output++ = 0xC0; *output++ = 0x00;
    while (length--) {
      byte = *input++;
      switch (byte) {
        case 0xC0: *output++ = 0xDB; *output++ = 0xDC; break;
        case 0xDB: *output++ = 0xDB; *output++ = 0xDD; break;
        default: *output++ = byte;
      }
    }
    *output++ = 0xC0;
    return output - output_start;
  } else {
    size_t outlen = 3;
    while (length--) {
      switch (*input++) {
        case 0xC0: case 0xDB: outlen++;
        default: outlen++;
      }
    }
    return outlen;
  }
}

size_t kiss_decode(uint8_t *buffer) {
  uint8_t *output = buffer, *input = buffer;
  uint8_t byte;
  int escaped = 0;
  input++;
  while ((byte = *input++) != 0xC0) {
    if (escaped) {
      if (byte == 0xDC) *output++ = 0xC0;
      else if (byte == 0xDD) *output++ = 0xDB;
      escaped = 0;
    } else {
      if (byte == 0xDB) escaped = 1;
      else *output++ = byte;
    }
  }
  return output-buffer;
}


