#include "qam.h"

#include <stdio.h>

static size_t writer(void *ctx, uint8_t *data, size_t length) {
  return fwrite(data, 1, length, stdout);
}

#define BUFSIZE 16

int main(int argc, char **argv) {
  uint8_t buffer[BUFSIZE];
  size_t length;
  qam_config_t config = QAM_DEFAULT_CONFIG;
  qam_modulator_t *state;
  qam_prepare_config(&config);
  state = qam_modulator_create(&config, writer, NULL);
  if (!state) {
    fprintf(stderr, "Could not initialize demodulator\n");
    return 1;
  }
  while (1) {
    length = fread(buffer, 1, BUFSIZE, stdin);
    if (!length) break;
    qam_modulator_send(state, buffer, length);
    while (!qam_modulator_run(state) && !ferror(stdout)) {}
  }
  qam_modulator_finish(state);
  while (!qam_modulator_run(state) && !ferror(stdout)) {}
  if (ferror(stdin) || ferror(stdout)) return 1;
  return 0;
}
